// Code generated by go-swagger; DO NOT EDIT.

// Copyright Prometheus Team
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package receiver

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetReceiversParams creates a new GetReceiversParams object
// with the default values initialized.
func NewGetReceiversParams() *GetReceiversParams {

	return &GetReceiversParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetReceiversParamsWithTimeout creates a new GetReceiversParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetReceiversParamsWithTimeout(timeout time.Duration) *GetReceiversParams {

	return &GetReceiversParams{

		timeout: timeout,
	}
}

// NewGetReceiversParamsWithContext creates a new GetReceiversParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetReceiversParamsWithContext(ctx context.Context) *GetReceiversParams {

	return &GetReceiversParams{

		Context: ctx,
	}
}

// NewGetReceiversParamsWithHTTPClient creates a new GetReceiversParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetReceiversParamsWithHTTPClient(client *http.Client) *GetReceiversParams {

	return &GetReceiversParams{
		HTTPClient: client,
	}
}

/*GetReceiversParams contains all the parameters to send to the API endpoint
for the get receivers operation typically these are written to a http.Request
*/
type GetReceiversParams struct {
	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get receivers params
func (o *GetReceiversParams) WithTimeout(timeout time.Duration) *GetReceiversParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get receivers params
func (o *GetReceiversParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get receivers params
func (o *GetReceiversParams) WithContext(ctx context.Context) *GetReceiversParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get receivers params
func (o *GetReceiversParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get receivers params
func (o *GetReceiversParams) WithHTTPClient(client *http.Client) *GetReceiversParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get receivers params
func (o *GetReceiversParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WriteToRequest writes these params to a swagger request
func (o *GetReceiversParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
